
;*****************************************************************************
;*                         BATTERIE-WCHTER                                  *
;*                              30.03.13                                     *
;*---------------------------------------------------------------------------*
;*                           BEGINN:30.03.13                                 *
;*                           ENDE  :30.03.13                                 *
;*                         GETESTET:30.03.13                                 *
;*****************************************************************************

        LIST    P=12F675       
        TITLE   "BATTERIE-WCHTER"

        ERRORLEVEL -302
        INCLUDE <P12F675.INC>

__CONFIG _INTRC_OSC_NOCLKOUT & _WDT_OFF & _PWRTE_OFF & _BODEN_OFF & _MCLRE_OFF & _CPD_OFF & _CP_OFF

;--------------------------------------------------------------------------


;--------------------------------------------------------------------------
;REGISTER ZUORDNEN NACH DEM DIE FESTEN-REGISTER ZU ENDE SIND
;ES GEHT ALSO ERST AB 22 HEX LOS
;DIES IST ALSO DIE RAM-SPEICHER ZUORDNUNG


MERK                    EQU     0X22
AD_H                    EQU     0X23
AD_L                    EQU     0X24


;------------------------- MACROS -----------------------------------------

BANK0                   MACRO                   ;MACRO TO SELECT DATA RAM BANK 0
                        BCF     STATUS,RP0
                        ENDM
;----------------------------------------------------------------------------
BANK1                   MACRO                   ;MACRO TO SELECT DATA RAM BANK 1
                        BSF     STATUS,RP0
                        ENDM
;----------------------------------------------------------------------------


;VARIABLEN
BIT0        EQU 0
BIT1        EQU 1
BIT2        EQU 2
BIT3        EQU 3
BIT4        EQU 4
BIT5        EQU 5
BIT6        EQU 6
BIT7        EQU 7



;SPEICHERANFANG BZW. BEGINN
    ORG 0X0000
    GOTO MAIN           ; SPRUNG ZUM HAUPTPROGRAMM
    ORG 0X0004
    RETFIE              ; SOFORT INTERRUPT


    ORG 0X0010
;*****************************************************************************
;*                            HAUPTPROGRAMM                                  *
;*                              30.03.13                                     *
;*****************************************************************************
;PORT-INITIALISIERUNG
MAIN                    BANK0
                        CLRF    GPIO     
                        MOVLW   0X07                        ;COMPARATORS ALLE AUS 
                        MOVWF   CMCON

                        BANK1
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;DIGITAL IO
                        MOVLW   B'00000001'                 ;GP0/AN0 ALS EINGANG (ALSO HIER DIE 1), GP1 BIS GP5 ALS AUSGANG HIER DIE 0
                        MOVWF   TRISIO

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;ANALOG/DIGITAL
                        MOVLW   B'00110001'                 ;ANALOG/DIGITAL
                        MOVWF   ANSEL                       ;GP4 + GP5 DIGITAL I/O     AN0 -ANALOG/DIGITAL WANDLER MIT RC-TAKT-INTERN  
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;KALIBRIERUNGSWERT FR DEN INTERNEN OSZILLATOR AM ENDE DES HAUPTSPEICHERS BERNEHMEN
                        CALL    0X03FF                  
                        MOVWF   OSCCAL 

;INIT TIMER 0 
;(HIER MUSS MAN IN DEM DATENBLATT (DATASHEET) BEI WWW.MICROCHIP.COM (EIN *.PDF-FILE) NACHSEHEN, WIE ALLES FUNKTIONIERT)
                        MOVLW   B'10000111'             ;BIT0-2 111=PRESCALER256, BIT3 0=TMR0, BIT4 0=ENTFAELLT, BIT5 0=TAKT VOM SYSTEM, BIT6 0=KEIN RB-INTERRUPT, BIT7 1=PULL-UPS DISABLE 
                        MOVWF   OPTION_REG      
                        BANK0

;INIT TIMER 1 
;                        MOVLW   B'00110000' ;BIT0 STOP-TIMER [0], BIT1 INTERNAL CLOCK [0], BIT2 EGAL [0], BIT3 OSZIL. OFF [0], BIT4-5 PRESCALER ALLES [11]1:8 VORERST 0
;                        MOVWF   T1CON

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;ANALOG/DIGITAL
                        MOVLW   B'10000000' ;ADMF=0 RECHTSBNDIG, VDD ALS REF, CHANNEL AN0, NO GO BIT1, NO ADON BIT0
                        MOVWF   ADCON0

;INIT ENDE
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;


;ALLE LEDS SOLLEN AM ANFANG AUS SEIN --- DIE GRNE MUSS DENNOCH LEUCHTEN GLEICH BEIM EINSCHALTEN /// ALS KONTROLL-LED 1SEC LANG DANN MISST ES               
                        CLRF   GPIO

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;ZEITSCHLEIFE 500MSEC   ZUM AUFLADEN VON 47NF KONDENSATOR AM SCHLEIFER VOM EINSTELLREGLER FR AD-MESSUNG........
ANFANG                  MOVLW   D'10'      ;10*10MSEC=100MSEC
                        CALL    ZS10MSEC

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;MESSEN
                        CALL    AD
                        ;CLRF    GPIO

                MOVLW   0X02
                SUBWF   AD_H, W
                BTFSC   STATUS, Z                
                GOTO    WEITERA

                MOVLW   0X02
                SUBWF   AD_H, W
                BTFSS   STATUS, C                
                GOTO    WEITER3

                BSF     GPIO, GP1
                GOTO    WEITER4

;GRER ALS 13,0VOLT
WEITERA         MOVLW   0X94
                SUBWF   AD_L, W
                BTFSS   STATUS, C                
                GOTO    WEITER1

                BSF     GPIO, GP1
                BCF     GPIO, GP2
                BCF     GPIO, GP4
                BCF     GPIO, GP5
                GOTO    WEITER4


;ZWISCHEN 13,0V UND 12,3VOLT
WEITER1         MOVLW   0X70                ;GRER 12,3V
                SUBWF   AD_L, W
                BTFSS   STATUS, C                
                GOTO    WEITER2

                BCF     GPIO, GP1
                BSF     GPIO, GP2
                BCF     GPIO, GP4
                BCF     GPIO, GP5
                GOTO    WEITER4


;ZWISCHEN 10,9V UND 12,3VOLT
WEITER2         MOVLW   0X2A                ;GRER 10,9V
                SUBWF   AD_L, W
                BTFSS   STATUS, C                
                GOTO    WEITER3

                BCF     GPIO, GP1
                BCF     GPIO, GP2
                BSF     GPIO, GP4
                BCF     GPIO, GP5
      
                GOTO    WEITER4

;KLEINER ALS 10,9VOLT
WEITER3         
                BCF     GPIO, GP1
                BCF     GPIO, GP2
                BCF     GPIO, GP4
                BSF     GPIO, GP5          

WEITER4         GOTO    ANFANG

;BERECHNUNG DER SPANNUNGEN:
;ES WURDEN FOLGENDE BATTERIE-SPANNUNGEN AUSGEWHLT, WO EINE LED LEUCHTEN SOLL ODER NICHT:
;13,0V
;12,3V
;11,6V
;10,9V
;ES WIRD DIE SPANNUNG AN AN0 MIT AD-WANDLUNG GEMESSEN.
;DAS ERGEBNIS SIND 2 BYTE BEI AD_H UND AD_L
;ALS REFERENZSPANNUNG WIRD DIE BETRIEBSSPANNUNG VOM PIC GENOMMEN, ALSO 5,0VOLT JE NACH SPANNUNGSREGLER SPANNUNG, KANN AUCH 4,85V SEIN....
;MAN KANN ALSO NUR SPANNUNGEN MESSEN WELCHE KLEINER ALS 5,0V SIND
;DESHALB WURDE EIN SPANNUNGSTEILER EINGESETZT
;ES ERGIBT SICH DARAUS FOLGENDES: BEI 13,0V LIEGEN AN AN0 :
;13V * (3,3K / (3,3K+10K))= 3,2255 VOLT
;UND DIE ANDEREN SPANNUNGEN:
;13,0V  3,2255V
;12,3V  3,0518V
;11,6V  2,8781V
;10,9V  2,7045V
;DIES MUSS NUN IN EINEN DIGITALEN 2BYTE WERT BERECHNET WERDEN (MIT PROPORTION)
;ES GILT: 1023DEZ 0X03FFHEX SIND 5,0V
;ES ERGIBT SICH DARAUS MIT PROPORTION:
;(1023*3,2255V)/5,0V=CA.660DEZ  DANN UMRECHNEN AM TASCHENRECHNER VON DEZ AUF HEX ,,, 660DEZ=294HEX
;13,0V  3,2255V  660DEZ 0X0294 ALSO DIE HEX-WERTE 0X02 UND 0X94
;12,3V  3,0518V  624DEZ 0X0270
;11,6V  2,8781V  589DEZ 0X024D
;10,9V  2,7045V  554DEZ 0X022A
;DIESE 2BYTE HEX-WERTE WURDEN IM PROGRAMM OBEN BENUTZT
;WILL MAN DIE SPANNUNGSANZEIGE NDERN MUSS MAN DIESE WERTE NDERN !!!!!!!!

;ES IST KEINE JUSTAGE NOTWENDIG!!!


;*****************************************************************************
;*         UNTERPROGRAMM ZUM STARTEN DES INTERRUPTS                          *
;*                              30.03.13                                     *
;*****************************************************************************

;AD-WANDLUNG
AD              BCF     PIR1, ADIF

;ANALOG/DIGITAL-WANDLUNG STARTEN
                BSF     ADCON0, ADON        ;SETZT SICH AUTOMATISCH WENN AD-WANDLUNG ERFOLGT
                CALL    ZS40MUE             ;ZEITSCHLEIFE
                BSF     ADCON0, GO_DONE     ;GEHT LOS
                CALL    ZS40MUE             ;ZEITSCHLEIFE

III             BTFSS  PIR1, ADIF
                GOTO   III

;ANALOG/DIGITAL-WANDLUNG STOPPEN
                BCF     ADCON0, ADON        
                BCF     ADCON0, GO_DONE    

;AD-ERGEBNIS ABSPEICHERN IN RAM-ZELLEN
                MOVF    ADRESH, W
                MOVWF   AD_H

                BANK1
                MOVF    ADRESL, W
                BANK0
                MOVWF   AD_L

                RETURN
  
;*****************************************************************************
;*         UNTERPROGRAMM MIT TIMER0 ALS ZEITSCHLEIFE FUER  10MSEC ....       *
;*                              30.03.13                                     *
;*****************************************************************************
ZS10MSEC                MOVWF   MERK                   ;DER INHALT VON W WIRD IN "MERK" GELADEN

T01                     MOVLW   D'217'
                        MOVWF   TMR0                    ;DER FESTE RAM-SPEICHER (TMR0) WIRD MIT 217 GELADEN
                        BCF     INTCON, T0IF            ;OVERFLOW = 0
                
T02                     BTFSS   INTCON, T0IF            ;WENN DIE ZEIT VON 10MSEC ABGELAUFEN IST, WIRD T0IF HIGH (1) UND 
                        GOTO    T02                     ;ES ERFOLGT EIN SPRUNG ZU "DECFSC MERK, F"
                        
                        DECFSZ  MERK, F                ;ES WIRD DER WERT IN "MERK" ABWRTS GEZHLT, BIS ER (0) IST UND
                        GOTO    T01                     ;DANN ERFOLGT EIN SPRUNG ZU "RETURN"-ENDE DES UNTERPROGRAMMS
                        RETURN
                


;ZEITBERECHNUNG FUER 10MS
;(HIER MUSS MAN IN DEM DATENBLATT (DATASHEET) BEI WWW.MICROCHIP.COM (EIN *.PDF-FILE) NACHSEHEN, WIE ALLES FUNKTIONIERT)

;PRESCALER 256X  *  SYSTEM 4X  * TAKTZEIT ====> 256*4*0.25S=256S   /DIE TAKTZEIT ERGIBT SICH AUS DEM INTERNEN OSZILLATOR
;10MS : 256S= 39                                                    /T = 1 : F  (F)-OSZILLATORFREQUENZ
;ALSO
;256S*D'39'=10MS
;TMR0 ALSO D'256'-D'39'=D'217' ENTSPRICHT CA. 10MS
;217 DEZIMAL OBEN EINTRAGEN

             
;*****************************************************************************
;*                              CA. 40SEC ZEITSCHLEIFE                      *
;*                              30.03.13                                     *
;*****************************************************************************

ZS40MUE     MOVLW   D'4'
            MOVWF   MERK
MSA         NOP             
            NOP         
            NOP
            NOP
            NOP
            NOP
            NOP
            DECFSZ  MERK, F
            GOTO    MSA
            RETURN




            END