;****************************************************************************************
;*                           LED-LICHTEFFEKTE VON DL3UKH                                *
;*                           ===========================                                *
;*                                                                                      *
;*--------------------------------------------------------------------------------------*
;* PORT-PIN-ZUORDNUNG:                                                                  *
;*                                                                                      *
;* GP2 -PIN5   -HIER KOMMEN DIE POSITIVEN IMPULSE RAUS, BEI +5V LEUCHTET ALSO DIE LED   *
;*                                                                                      *
;* GP0 , GP1 UND GP3 SOLLTE MAN NICHT ANSCHLIESSEN,                                     *
;* DIE EINGAENGE WERDEN BEIM  SERIELLEN ICSP-PROGRAMMIEREN DES PIC BENUTZT              *
;* MAN KOENNTE HIER STIFTE BEI DER LEITERPLATTE VORSEHEN UND IM                         *
;* EINGELOETETEN ZUSTAND DEN PIC PROGRAMMIEREN                                          *
;* ODER                                                                                 *
;* MAN STECKT DEN PIC IN EINE FASSUNG UND KANN DIESEN DANN JEDERZEIT AUCH WIEDER        *
;* HERAUS ZIEHEN UND NEU PROGRAMMIEREN                                                  *
;*                                                                                      *
;*  FUNKTIONSPRINZIP:                                                                   *
;*  HIER WIRD DIE HELLIGKEIT EINER LED GESTEUERT.                                       *
;*  DABEI WIRD DIE LED GETAKTET. ES LIEGT ALSO GROB GESAGT EINE WECHSELSPANNUNG AN      *
;*  DER LED.                                                                            *
;*  ES IST EIN AUFSCHWELLEN DER HELLIGKEIT EINER LED.                                   *
;*  INNERHALB VON SEC WIRD DIE HELLIGKEIT HOCHGEFAHREN.                                 *
;*                                                                                      *
;*                                                                                      *
;*  DIE WECHSEL- BZW. SCHALTSPANNUNG SCHALTET DIE LED EINE ZEIT LANG EIN (SIE LEUCHTET) *
;*  UND EINE ZEIT LANG AUS (SIE IST VERLOSCHEN)                                         *
;*  DIES ERFOLGT SEHR SCHNELL. MAN SIEHT MIT DEM MENSCHLICHEN AUGE DAS AUS- UND         *
;*  EINSCHALTEN NICHT.                                                                  *
;*  WENN MAN NUN DIE ZEITDAUER BEI EIN-DER-LED UND BEI AUS-DER-LED VERNDERT, MERKT     *
;*  MAN DIE LED LEUCHTET IMMER HELLER.                                                  *
;*  DIES WIRD HIER IM PROGRAMM GENUTZT. MAN NENNT SO ETWAS DIMMER.                      *
;*                                                                                      *
;*  HIER DIE TAKT-, WECHSEL- ODER SCHALTSPANNUNGSVERHLTNISSE, WIE SIE IM PROGRAMM      *
;*  VERWENDET WERDEN--->                                                                *
;*  FR FAST AUS DER LED GILT:                  18SEC AUS UND 3,6MSEC EIN              *
;*  DIES WIRD KONTINUIERLICH VERNDERT                                                  *
;*  BIS DIE LED FAST EIN IST MIT               3,6MSEC AUS UND 18SEC EIN               *
;*                                                                                      *
;*  HIER WERDEN EIGENTLICH 201 SCHRITTE DURCHLAUFEN MIT JEWEILS EINER DAUER VON 5MSEC   *
;*  201-SCHRITTE A (*) 5MSEC = CA. 1,0SEC HOCH UND 2X BLINKEN                           *
;*                                                                                      *
;*                                                                                      *
;*--------------------------------------------------------------------------------------*
;*                                                                                      *
;* ALS PIC-IC WURDE GENOMMEN PIC12F629-I/P                                              *
;* DER OSZILLATOR IST EIN INTERNER OSZILLATOR MIT 4MHZ.  (T=0.25S)                     *
;*                                                                                      *
;*--------------------------------------------------------------------------------------*
;*                           BEGINN: 30.12.14                                           *
;*                           ENDE  :                                                    *
;*                         GETESTET:                                                    *
;****************************************************************************************

        LIST    P=12F629       
        TITLE   "LED-LICHTEFFEKT-PFEIFFER"

        ERRORLEVEL -302

        INCLUDE <P12F629.INC>


__CONFIG _INTRC_OSC_NOCLKOUT & _WDT_OFF & _PWRTE_OFF & _BODEN_OFF & _MCLRE_OFF & _CPD_OFF & _CP_OFF

;--------------------------------------------------------------------------
;REGISTER ZUORDNEN NACH DEM DIE FESTEN-REGISTER ZU ENDE SIND
;ES GEHT ALSO ERST AB 22 HEX LOS
;DIES IST ALSO DIE RAM-SPEICHER ZUORDNUNG

                        ORG 22H 

ZAE_AN                  EQU     0X22               ;ZAEHLER FR AN
ZAE_AUS                 EQU     0X23               ;AUCH EIN ZAEHLER NUR FR AUS
MERK                    EQU     0X24               ;MERKER
MERK1                   EQU     0X25               ;MERKER

;PORT PIN ZUORDNUNG
LED                     EQU     2                  ;LED AN PORT GP2
LED1                    EQU     1                  ;LED AN PORT GP1
;MAN BEACHTE "TRISIO" DANN AUCH FR GP2+1 ALS AUSGANG INITIALISIEREN !!!!!

EINAUS                  EQU     5                  ;AN PORT GP5
ANDER_BLINK             EQU     4                  ;AN PORT GP4

;------------------------- MACROS -----------------------------------------

BANK0                   MACRO                   ;MACRO TO SELECT DATA RAM BANK 0
                        BCF     STATUS,RP0
                        ENDM

BANK1                   MACRO                   ;MACRO TO SELECT DATA RAM BANK 1
                        BSF     STATUS,RP0
                        ENDM

;---------------------------------------------------------------------------------
;SPEICHERANFANG BZW. BEGINN

                        ORG 0X0000
                        GOTO MAIN               ; SPRUNG ZUM HAUPTPROGRAMM
                        ORG 0X0004
                        RETFIE                  ; BEI EINEM INTERRUPT SOFORT EIN RETURN

                        ORG 0X0010

;*****************************************************************************
;*                            HAUPTPROGRAMM   MIT DEM NAMEN "MAIN"           *
;*                              24.08.10                                     *
;*****************************************************************************
;PORT-INITIALISIERUNG
MAIN                    BANK0
                        CLRF    GPIO     
                        MOVLW   0X07                    ;COMPARATORS ALLE AUS 
                        MOVWF   CMCON

                        BANK1
                        MOVLW   B'11111001'             ;GP2+1 ALS AUSGANG (ALSO HIER DIE 0), SONST ALLES EINGNGE (ALSO IMMER DIE (1)) 
                        MOVWF   TRISIO

;KALIBRIERUNGSWERT AM ENDE DES HAUPTSPEICHERS BERNEHMEN
                        CALL    0X03FF                  
                        MOVWF   OSCCAL

;INIT TIMER 0 FUER 10MSEC FUER ZEITSCHLEIFE
;(HIER MUSS MAN IN DEM DATENBLATT (DATASHEET) BEI WWW.MICROCHIP.COM (EIN *.PDF-FILE) NACHSEHEN, WIE ALLES FUNKTIONIERT)
                        MOVLW   B'10000111'             ;BIT0-2 1=PRESCALER256, BIT3 0=TMR0, BIT4 0=ENTFAELLT, BIT5 0=TAKT VOM SYSTEM, BIT6 0=KEIN RB-INTERRUPT, BIT7 1=PULL-UPS DISABLE 
                        MOVWF   OPTION_REG      
                        BANK0
;INIT TIMER1
                        MOVLW   0X30                ;PRESCALE1:8 / SYSTEMCLOCK T/4 ==>1/32
                        MOVWF   T1CON               

;DIE LEDS SOLLEN AM ANFANG AUS SEIN                
                        CALL    AUS

;ZEITSCHLEIFE ZUR SICHERHEIT
                        MOVLW   D'50'           ;ZEISCHLEIFE LADEN MIT 50*10MSEC=500MSEC
                        CALL    ZS10MSEC        ;ZEITSCHLEIFE ABARBEITEN

;---------------INITIALISIERUNG--ZU--ENDE-----------------------

                       
;------
;ABFRAGE OB ANHALTEN / SCHALTER GP5
ANFANG                  BTFSS   GPIO, EINAUS
                        GOTO    ANFANG
;------
;ABFRAGE OB BEI ZU NIEDRIGER BATTERIESPANNUNG ANDERS BLINKEN
                        BTFSC   GPIO, ANDER_BLINK
                        GOTO    ANDERS

                        MOVLW   D'200'
                        MOVWF   ZAE_AUS
                        MOVLW   D'1'
                        MOVWF   ZAE_AN


;SO WIRD LANGSAM VON GANZ DUNKEL (ZAE_AUS=200 UND ZAE_AN=1) BIS HELL HOCH GEFAHREN
;MIT WEITER ZAE_AUS=199  ZAE_AN=2
;MIT WEITER ZAE_AUS=198  ZAE_AN=3
;MIT WEITER ZAE_AUS=197  ZAE_AN=4
;MIT WEITER ZAE_AUS=196  ZAE_AN=5
;....
;BIS FOLGENDES ERREICHT IST
;           ZAE_AUS=1    ZAE_AN=200  JETZT LEUCHTE DIE LED AM HELLSTEN

;MIT JEWEILS JEDEM ZYKLUS VON 5MSEC

;DA ES 200ZYKLEN SIND GILT: 200 * 5MSEC = 1SEC ; ALSO 1SEC DAUERT EINMAL HOCHFAHREN (HELLIGKEITSZUNAHME)

W00                     CALL    ZS_5            ;LADEN VON 5MSEC ALSO INITIALISIEREN !

W01                     CALL    EIN             ;LED AN
                        MOVF    ZAE_AN, W       ;AM ANFANG BEI ZAE_AN=1 WREN DIES 18SEC FR ZS
                        CALL    ZS

                        CALL    AUS             ;LED AUS
                        MOVF    ZAE_AUS, W      ;AM ANFANG BEI ZAE_AUS=200 WREN DIES 3,6MSEC FR ZS
                        CALL    ZS

                        BTFSS   INTCON, T0IF    ;ABFRAGE OB 5MSEC ZU ENDE SIND, WENN JA WIRD GOTO W01 BERSPRUNGEN, ES GEHT MIT INCF.. WEITER            
                        GOTO    W01

                        INCF    ZAE_AN, F       ;NACH DEN ALSO 10MSEC ZU ENDE SIND WIRD ZAE_AN UM 1 ERHHT, ALSO 1+1=2
                        DECF    ZAE_AUS, F      ;UND ZAE_AUS WIRD UM 1 ERNIEDRIGT; ALSO 200-1=199

                        MOVLW   D'80'                  
                        SUBWF   ZAE_AUS, W      
                        BTFSC   STATUS, C       
                        GOTO    W00           

                        INCF    ZAE_AN, F       
                        DECF    ZAE_AUS, F 
                        INCF    ZAE_AN, F       
                        DECF    ZAE_AUS, F      

W02                     MOVLW   D'5'            ;HIER WIRD NACH GEFRAGT OB ZAE_AUS DEN WERT 1 ERREICHT HAT        
                        SUBWF   ZAE_AUS, W      ;WENN JA
                        BTFSC   STATUS, C       ;WIRD GOTO W00 BERSPRUNGEN UND ES GEHT WEITER BEI A00  
                        GOTO    W00             ;;;;;; ALSO WENN ES NICHT ZAE_AUS=1 IST GEHT ES NACH OBEN ZUR MARKE W00


;-------
;BLINKEN SOLL ES JETZT / ZUERST PAUSE  MIT NICHT LEUCHTEN
;-------
A00                     CALL    AUS             ;LED AUS

;PAUSEN ZEITSCHLEIFE
                        MOVLW   D'10'           ;ZEISCHLEIFE LADEN MIT 40*10MSEC=400MSEC
                        CALL    ZS10MSEC        ;ZEITSCHLEIFE ABARBEITEN

;------
;1.MAL LED LEUCHTET 200MSEC
                        CALL    EIN            ;LED EIN
;ZEITSCHLEIFE
                        MOVLW   D'5'           ;ZEISCHLEIFE LADEN MIT 20*10MSEC=200MSEC
                        CALL    ZS10MSEC        ;ZEITSCHLEIFE ABARBEITEN

                        CALL    AUS            ;LED AUS
;------
;PAUSEN ZEITSCHLEIFE
                        MOVLW   D'10'           ;ZEISCHLEIFE LADEN MIT 20*10MSEC=200MSEC
                        CALL    ZS10MSEC        ;ZEITSCHLEIFE ABARBEITEN

;------

;------
;2.MAL LED LEUCHTET 200MSEC
                        CALL    EIN            ;LED EIN
;ZEITSCHLEIFE
                        MOVLW   D'5'           ;ZEISCHLEIFE LADEN MIT 20*10MSEC=200MSEC
                        CALL    ZS10MSEC        ;ZEITSCHLEIFE ABARBEITEN

                        CALL    AUS            ;LED AUS
;------
;PAUSEN ZEITSCHLEIFE
                        MOVLW   D'50'           ;ZEISCHLEIFE LADEN MIT 50*10MSEC=500MSEC
                        CALL    ZS10MSEC        ;ZEITSCHLEIFE ABARBEITEN

;------
;ES GEHT VON VORNE LOS
                        GOTO    ANFANG

;------
;------
;------
;ANDERS BLINKEN !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
ANDERS                  CALL    AUS             ;LED AUS

;------
;PAUSEN ZEITSCHLEIFE
                        MOVLW   D'4'           ;ZEISCHLEIFE LADEN MIT 4*500MSEC=2SEC
                        CALL    ZS500MSEC      ;ZEITSCHLEIFE ABARBEITEN


;1.MAL LED LEUCHTET 50MSEC
                        CALL    EIN            ;LED EIN
;ZEITSCHLEIFE
                        MOVLW   D'5'           ;ZEISCHLEIFE LADEN MIT 5*10MSEC=50MSEC
                        CALL    ZS10MSEC       ;ZEITSCHLEIFE ABARBEITEN

                        CALL    AUS            ;LED AUS
;------
;PAUSEN ZEITSCHLEIFE
                        MOVLW   D'10'           ;ZEISCHLEIFE LADEN MIT 10*10MSEC=100MSEC
                        CALL    ZS10MSEC        ;ZEITSCHLEIFE ABARBEITEN

;2.MAL LED LEUCHTET 200MSEC
                        CALL    EIN            ;LED EIN
;ZEITSCHLEIFE
                        MOVLW   D'5'           ;ZEISCHLEIFE LADEN MIT 5*10MSEC=50MSEC
                        CALL    ZS10MSEC       ;ZEITSCHLEIFE ABARBEITEN

                        CALL    AUS            ;LED AUS

;PAUSEN ZEITSCHLEIFE
                        MOVLW   D'4'           ;ZEISCHLEIFE LADEN MIT 4*500MSEC=2SEC
                        CALL    ZS500MSEC      ;ZEITSCHLEIFE ABARBEITEN

;------
;ES GEHT VON VORNE LOS
                        GOTO    ANFANG





;*****************************************************************************
;*                              EIN                                          *
;*                                                                           *
;*****************************************************************************
EIN                 BSF     GPIO, LED
                    BSF     GPIO, LED1
                    RETURN


;*****************************************************************************
;*                              AUS                                          *
;*                                                                           *
;*****************************************************************************
AUS                 BCF     GPIO, LED
                    BCF     GPIO, LED1
                    RETURN



;*****************************************************************************
;*  UNTERPROGRAMM MIT TIMER0 HIER WERDEN 10MSEC MIT FAKTOR MERK ABGEARBEITET *
;*                              24.08.10                                     *
;*                                                                           *
;*                                                                           *
;*                                                                           *
;*****************************************************************************
ZS10MSEC                MOVWF   MERK

;INITIALISIERUNG TIMER 0 FR 10MSEC
ZS_INI                  MOVLW   D'217'
                        MOVWF   TMR0
                        BCF     INTCON, T0IF            ;OVERFLOW = 0


ZS_1                    BTFSS   INTCON, T0IF            ;ABFRAGE OB 10MSEC ZU ENDE SIND, WENN JA GEHT ES ZUM BEFEHL DECFSZ...            
                        GOTO    ZS_1


                        DECFSZ  MERK, F                 ;MERK WIRD IMMER -1 GEMACHT
                        GOTO    ZS_INI                  ;WENN NICHT 0 ERREICHT GEHT ES ZU ZS_INI (INITIALISIERUNG TIMER0)
                
                        RETURN                          ;BEI MERK=0 WIRD UNTERPROGRAMM MIT RETURN VERLASSEN

;ZEITBERECHNUNG FUER 10MS
;(HIER MUSS MAN IN DEM DATENBLATT (DATASHEET) BEI WWW.MICROCHIP.COM (EIN *.PDF-FILE) NACHSEHEN, WIE ALLES FUNKTIONIERT)

;PRESCALER 256X  *  SYSTEM 4X  * TAKTZEIT ====> 256*4*0.25S=256S   /DIE TAKTZEIT ERGIBT SICH AUS DEM INTERNEN OSZILLATOR
;10MS : 256S= 39                                                    /T = 1 : F  (F)-OSZILLATORFREQUENZ
;ALSO
;256S*D'39'=10MS
;TMR0 ALSO D'256'-D'39'=D'217' ENTSPRICHT CA. 10MS
;217 DEZIMAL OBEN EINTRAGEN

;*****************************************************************************
;*         UNTERPROGRAMM ALS ZEITSCHLEIFE FUER  18SEC                       *
;*                              24.08.10                                     *
;*****************************************************************************
ZS                      MOVWF   MERK

T00                     MOVLW   D'3'
                        MOVWF   MERK1
T01                     NOP
                        NOP
                        NOP
                        DECFSZ  MERK1, F
                        GOTO    T01

                        DECFSZ  MERK, F
                        GOTO    T00

                        RETURN
                
;*****************************************************************************
;*  UNTERPROGRAMM MIT TIMER0 HIER WIRD DER NUR DER WERT FR 5MSEC GELADEN    *
;*                              24.08.10                                     *
;*                                                                           *
;*  DER ZYKLUS VON AN UND AUS DER LED (SIEHE IM HAUPTPROGRAMM BEI "ANFANG"   *
;*  UND BEIM UNTERPRG. ZS) WIRD 5MSEC LANG DURCHLAUFEN                       *
;*                                                                           *
;*                                                                           *
;*****************************************************************************
ZS_5                    MOVLW   D'254'
                        MOVWF   TMR0
                        BCF     INTCON, T0IF            ;OVERFLOW = 0
                
                        RETURN

;ZEITBERECHNUNG FUER 3MS
;(HIER MUSS MAN IN DEM DATENBLATT (DATASHEET) BEI WWW.MICROCHIP.COM (EIN *.PDF-FILE) NACHSEHEN, WIE ALLES FUNKTIONIERT)

;PRESCALER 256X  *  SYSTEM 4X  * TAKTZEIT ====> 256*4*0.25S=256S   /DIE TAKTZEIT ERGIBT SICH AUS DEM INTERNEN OSZILLATOR
;3MS : 256S= 12                                                    /T = 1 : F  (F)-OSZILLATORFREQUENZ
;ALSO
;256S*D'12'=3MS
;TMR0 ALSO D'256'-D'12'=D'244' ENTSPRICHT CA. 3MS
;237 DEZIMAL OBEN EINTRAGEN


;*****************************************************************************
;*                              TIMER1 500MSEC * X                           *
;*                                                                           *
;*****************************************************************************
ZS500MSEC   MOVWF   MERK

ZS00        BCF     T1CON, TMR1ON       ;STOP TIMER1
            MOVLW   0X0B                
            MOVWF   TMR1H               
            MOVLW   0XDC
            MOVWF   TMR1L
            BCF     PIR1, TMR1IF        ;OVERFLOW 0 MACHEN
            BSF     T1CON, TMR1ON       ;START TIMER1

ZS01        BTFSS   PIR1, TMR1IF        ;OVERFLOW KONTROLLIEREN BEI 500MSEC
            GOTO    ZS01

            DECFSZ  MERK, F
            GOTO    ZS00

            RETURN


;TIMER1:
;32 * 0.250SEC = 8SEC
;500MSEC : 8SEC = 62.500
;65536 (0X10000) - 62500 = 3036 IN HEX.0X0BDC
;BEI TMR1H 0X0B EINTRAGEN BERECHNET
;BEI TMR1L 0XDC EINTRAGEN BERECHNET









                        END